from math import *


#Implementation du 3)e)
def et(x1:int,x2:int)->int:
    z=0.8*x1+0.8*x2-1
    s=1/(1+exp(-z))
    return int(s>=0.5)

assert(et(0,0)==0)
assert(et(0,1)==0)
assert(et(1,0)==0)
assert(et(1,1)==1)

#Implementation du 4)b)
def ou(x1:int,x2:int)->int:
    z=-0.8*x1+0.8*x2-1
    s=1/(1+exp(-z))
    return int(s>=0.5)

assert(et(0,0)==0)
assert(et(0,1)==0)
assert(et(1,0)==0)
assert(et(1,1)==1)



def logic_function(wi:tuple, x1:int,x2:int)->int:
    z=-1*wi[0]+x1*wi[1]+x2*wi[2]
    s= 1/(1+exp(-z))
    if s>=0.5:
        return 1
    else:
        return 0


weight={"et":(1,0.8,0.8),"ou":(1,2,2),"non ou":(-1,-2,-2)}

#Assertions de la fonction logique ET (AND)
assert( logic_function(weight["et"],0,0)==0)
assert( logic_function(weight["et"],0,1)==0)
assert( logic_function(weight["et"],1,0)==0)
assert( logic_function(weight["et"],1,1)==1)

#Assertions de la fonction logique OU (OR)
assert( logic_function(weight["ou"],0,0)==0)
assert( logic_function(weight["ou"],0,1)==1)
assert( logic_function(weight["ou"],1,0)==1)
assert( logic_function(weight["ou"],1,1)==1)

#Assertions de la fonction logique NON OU (NOR)
assert( logic_function(weight["non ou"],0,0)==1)
assert( logic_function(weight["non ou"],0,1)==0)
assert( logic_function(weight["non ou"],1,0)==0)
assert( logic_function(weight["non ou"],1,1)==0)

#implementation du OU EXCLUSIF il faudra ici 3 couches de neurones
def xor(x1:int,x2:int)->int:
    S1=logic_function(weight["non ou"],x1,x2)
    S2=logic_function(weight["non ou"],S1,x2)
    S3=logic_function(weight["non ou"],S1,x1)
    return logic_function(weight["ou"],S2,S3)

#Assertions de la fonction logique OU EXCLUSIF (XOR)
assert(xor(0,0)==0)
assert(xor(0,1)==1)
assert(xor(1,0)==1)
assert(xor(1,1)==0)